#include <stdio.h>

/* 
deklaracija funkcije koja ce 
provjeravati uvjete postavljene na sumande 
*/
int uvjet(int n);


/* 
funkcija koju trebamo implementirati
*/
int particije(int n, int zadnji){
	int i;
	int suma = 0;
	
	if(n == 0) return 1;
	if(n < 0) return 0;
	
	for(i = zadnji; i <= n; ++i)
		if(uvjet(i)) suma += particije(n-i, i);
		
	return suma;
	}


/*
main funkcija za testiranje
*/
int main(void){
	int n;
	scanf("%d",&n);
	printf("%d\n",particije(n,1));
	return 0;
	}
	

/*
implementacija funkcije koja provjerava
uvjet postavljen na sumande.

4 varijante za 4 grupe
*/
#ifdef __GRUPA_A__
int uvjet(int n){
	int i;
	if(n < 2) return 0;
	for(i = 2; i*i < n; ++i)
		if(n % i == 0) return 0;
	return 1;
	}
#endif

#ifdef __GRUPA_B__
int uvjet(int n){
	int k = 3553;
	while(k > 0){
		int ostatak = n % k;
		n = k;
		k = ostatak;
		}
	return (n == 1);
	}
#endif

#ifdef __GRUPA_C__
int uvjet(int n){
	int z = 0;
	while(n > 0){
		++z;
		n /= 16;
		}
	return (z % 2 == 1);
	}
#endif

#ifdef __GRUPA_D__
/*
u broj djelitelja uracunavamo i kratnost
*/
int uvjet(int n){
	int d = 0;
	int i = 2;
	while(n > 1){
		while(n % i == 0){
			++d;
			n /= i;
			}
		++i;
		}
	return (d % 2 == 0);
	}
#endif
